package cs108;

import java.util.ArrayList;
import java.util.List;

public abstract class AbstractSubject implements Subject {
    private final List<Observer> observers = new ArrayList<>();

    @Override
    public void addObserver(Observer o) {
        observers.add(o);
    }

    @Override
    public void removeObserver(Observer o) {
        observers.remove(o);
    }

    protected void notifyObservers() {
        observers.forEach(o -> o.update(this));
    }
}
